#pragma once
#include <States/GameState/Entities/IEntity.h>

struct IStaticEntity : IEntity {
   [[nodiscard]] virtual std::unique_ptr<IStaticEntity> clone() const = 0;
   ~IStaticEntity() override = default;
};

class Food : public IStaticEntity {
public:
    Food();
    [[nodiscard]] std::unique_ptr<IStaticEntity> clone() const override;
    void draw_into(sf::RenderWindow& window) const override;
    void prepare_for_drawing() override;
private:
    sf::CircleShape m_circle;
};