#pragma once

#include <States/GameState/IPreparable.h>
#include <States/GameState/Maze/RoomSide.h>

#include <array>

struct IRoomSide;

class Room: public IDrawable {
public:
    enum Direction { INVALID = -1, LEFT, RIGHT, UP, DOWN };
    explicit Room(float size);
    float get_size() const noexcept { return m_rectangle.getSize().x; }
    void set_position(const sf::Vector2f pos) { m_rectangle.setPosition(pos); }
    sf::Vector2f get_position() const noexcept { return m_rectangle.getPosition(); }
    void set_side(Direction side, std::shared_ptr<IRoomSide>&& ptr_side);
    IRoomSide* get_side(const Direction side) const noexcept { return m_sides[side].get(); }
    Direction get_direction(const IRoomSide* ptr_side) const;
    void draw_into(sf::RenderWindow& window) const override;
private:
    sf::RectangleShape m_rectangle;
    std::array<std::shared_ptr<IRoomSide>, 4> m_sides; ///< @todo shared_ptr? Две комнаты владеют одним IRoomSide
};

